# Change default IPC definition
IPC = syslink

# Required definitions for kernel module builds
LINUXKERNEL_CONFIG          = ti8168_evm_defconfig
LINUXKERNEL_INSTALL_DIR     ?= $(HOME)/ti-ezsdk/c6a816x-evm_5_00_00_20110215/psp/linux-2.6.37-psp04.00.00.09
UBOOT_CONFIG                = ti8168_evm_config
UBOOT_INSTALL_DIR           ?= $(HOME)/ti-ezsdk/c6a816x-evm_5_00_00_20110215/psp/u-boot-2010.06-psp04.00.00.09

# Default memory map variables (can be overridden)
DSP_REGION_BASE_ADDR        ?= 0x94000000
DSP_REGION_CMEM_SIZE        ?= 0x01A00000
DSP_REGION_CODE_SIZE        ?= 0x01000000

PLATFORM_CFLAGS             = -DDSP_REGION_BASE_ADDR=$(DSP_REGION_BASE_ADDR) -DDSP_REGION_CMEM_SIZE=$(DSP_REGION_CMEM_SIZE) -DDSP_REGION_CODE_SIZE=$(DSP_REGION_CODE_SIZE)

ifeq ($(IPC),dsplink)
  # DSPLink not supported
else
  # Required definitions for SysLink/SysBios6 builds
  SYSLINK_PLATFORM          = TI81XX
  SYSLINK_VARIANT           = TI816X
  SYSLINK_LOADER            = ELF
endif

# DSP Architecture Specific Compiler flags
DSP_CFLAGS                  = -mv6740 --abi=eabi

# GPP Architecture Specific Compiler flags (can be overridden)
CFLAGS                      ?= -march=armv7-a -mtune=cortex-a8 -mlittle-endian -mfloat-abi=softfp
